<html>
<head>
<title>OgrePose.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePose.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePose_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment"> Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OGRE_POSE_H</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_POSE_H</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00054"></a><a class="code" href="classOgre_1_1Pose.html">00054</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAlloc</a>
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056     <span class="keyword">public</span>:
<a name="l00062"></a>00062         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00063"></a>00063         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>();
<a name="l00065"></a><a class="code" href="classOgre_1_1Pose.html#a73c497f062296a446298258d3b500e86">00065</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Pose.html#a73c497f062296a446298258d3b500e86" title="Return the name of the pose (may be blank)">getName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00067"></a><a class="code" href="classOgre_1_1Pose.html#a8c18792868f8165a19ef645b9395a20b">00067</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1Pose.html#a8c18792868f8165a19ef645b9395a20b" title="Return the target geometry index of the pose.">getTarget</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTarget; }
<a name="l00069"></a><a class="code" href="classOgre_1_1Pose.html#a2508702f4d3791dc59ce9af8fdfa998e">00069</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;size_t, Vector3&gt;::type</a> <a class="code" href="classOgre_1_1Pose.html#a2508702f4d3791dc59ce9af8fdfa998e" title="A collection of vertex offsets based on the vertex index.">VertexOffsetMap</a>;
<a name="l00071"></a><a class="code" href="classOgre_1_1Pose.html#aab53719cd5a035c0b5ca9301c9927a9a">00071</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;VertexOffsetMap&gt;</a> <a class="code" href="classOgre_1_1Pose.html#aab53719cd5a035c0b5ca9301c9927a9a" title="An iterator over the vertex offsets.">VertexOffsetIterator</a>;
<a name="l00073"></a><a class="code" href="classOgre_1_1Pose.html#ab7830f6ad3feaf3740a8e6477d97cef5">00073</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;VertexOffsetMap&gt;</a> <a class="code" href="classOgre_1_1Pose.html#ab7830f6ad3feaf3740a8e6477d97cef5" title="An iterator over the vertex offsets.">ConstVertexOffsetIterator</a>;
<a name="l00075"></a><a class="code" href="classOgre_1_1Pose.html#a77b417702362e8a351c220dd4deeaf80">00075</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;size_t, Vector3&gt;::type</a> <a class="code" href="classOgre_1_1Pose.html#a77b417702362e8a351c220dd4deeaf80" title="A collection of normals based on the vertex index.">NormalsMap</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1Pose.html#a326485fc1f4fd6a07c4e21b0ddf165a3">00077</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;NormalsMap&gt;</a> <a class="code" href="classOgre_1_1Pose.html#a326485fc1f4fd6a07c4e21b0ddf165a3" title="An iterator over the vertex offsets.">NormalsIterator</a>;
<a name="l00079"></a><a class="code" href="classOgre_1_1Pose.html#a537dcec01c2cc2f8021e4c89aa9fdde9">00079</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;NormalsMap&gt;</a> <a class="code" href="classOgre_1_1Pose.html#a537dcec01c2cc2f8021e4c89aa9fdde9" title="An iterator over the vertex offsets.">ConstNormalsIterator</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1Pose.html#a32721dacadc6b0dfbef78318b3a41929">00081</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Pose.html#a32721dacadc6b0dfbef78318b3a41929" title="Return whether the pose vertices include normals.">getIncludesNormals</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !mNormalsMap.empty(); }
<a name="l00082"></a>00082 
<a name="l00087"></a>00087         <span class="keywordtype">void</span> addVertex(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; offset);
<a name="l00088"></a>00088 
<a name="l00093"></a>00093         <span class="keywordtype">void</span> addVertex(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; offset, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; normal);
<a name="l00094"></a>00094 
<a name="l00096"></a>00096         <span class="keywordtype">void</span> removeVertex(<span class="keywordtype">size_t</span> index);
<a name="l00097"></a>00097 
<a name="l00099"></a>00099         <span class="keywordtype">void</span> clearVertices(<span class="keywordtype">void</span>);
<a name="l00100"></a>00100 
<a name="l00102"></a>00102         ConstVertexOffsetIterator getVertexOffsetIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00104"></a>00104         VertexOffsetIterator getVertexOffsetIterator(<span class="keywordtype">void</span>);
<a name="l00106"></a><a class="code" href="classOgre_1_1Pose.html#a7216f1dac1bd9e0bec03160d2929248a">00106</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pose.html#a2508702f4d3791dc59ce9af8fdfa998e" title="A collection of vertex offsets based on the vertex index.">VertexOffsetMap</a>&amp; <a class="code" href="classOgre_1_1Pose.html#a7216f1dac1bd9e0bec03160d2929248a" title="Gets a const reference to the vertex offsets.">getVertexOffsets</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexOffsetMap; }
<a name="l00107"></a>00107 
<a name="l00109"></a>00109         ConstNormalsIterator getNormalsIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00111"></a>00111         NormalsIterator getNormalsIterator(<span class="keywordtype">void</span>);
<a name="l00113"></a><a class="code" href="classOgre_1_1Pose.html#a56c3f18962e02907fff9eba2c196250c">00113</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Pose.html#a77b417702362e8a351c220dd4deeaf80" title="A collection of normals based on the vertex index.">NormalsMap</a>&amp; <a class="code" href="classOgre_1_1Pose.html#a56c3f18962e02907fff9eba2c196250c" title="Gets a const reference to the vertex offsets.">getNormals</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNormalsMap; }
<a name="l00114"></a>00114 
<a name="l00116"></a>00116         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; _getHardwareVertexBuffer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* origData) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00121"></a>00121         <a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>* clone(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00122"></a>00122     <span class="keyword">protected</span>:
<a name="l00124"></a><a class="code" href="classOgre_1_1Pose.html#af23de51f107e8192583857cf230a574e">00124</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1Pose.html#af23de51f107e8192583857cf230a574e" title="Target geometry index.">mTarget</a>;
<a name="l00126"></a><a class="code" href="classOgre_1_1Pose.html#a4dfab7ef915235c4e3885054f0649c3e">00126</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Pose.html#a4dfab7ef915235c4e3885054f0649c3e" title="Optional name.">mName</a>;
<a name="l00128"></a><a class="code" href="classOgre_1_1Pose.html#ae0965a04e0b5b5285e29b10e646561a0">00128</a>         <a class="code" href="classOgre_1_1Pose.html#a2508702f4d3791dc59ce9af8fdfa998e" title="A collection of vertex offsets based on the vertex index.">VertexOffsetMap</a> <a class="code" href="classOgre_1_1Pose.html#ae0965a04e0b5b5285e29b10e646561a0" title="Primary storage, sparse vertex use.">mVertexOffsetMap</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1Pose.html#a9de08a9989c25596cd55706376beaf06">00130</a>         <a class="code" href="classOgre_1_1Pose.html#a77b417702362e8a351c220dd4deeaf80" title="A collection of normals based on the vertex index.">NormalsMap</a> <a class="code" href="classOgre_1_1Pose.html#a9de08a9989c25596cd55706376beaf06" title="Primary storage, sparse vertex use.">mNormalsMap</a>;
<a name="l00132"></a><a class="code" href="classOgre_1_1Pose.html#a4256531f55d7093373437ca1864115a5">00132</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1Pose.html#a4256531f55d7093373437ca1864115a5" title="Derived hardware buffer, covers all vertices.">mBuffer</a>;
<a name="l00133"></a>00133     };
<a name="l00134"></a><a class="code" href="group__Animation.html#ga2320179c7d0107995d8a737c86a40333">00134</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Pose*&gt;::type</a> <a class="code" href="group__Animation.html#ga2320179c7d0107995d8a737c86a40333">PoseList</a>;
<a name="l00135"></a>00135 
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
